import { Dialog } from "@mui/material";
import { DialogTitle } from "@mui/material";
import { DialogContent } from "@mui/material";
import { DialogContentText } from "@mui/material";
import { DialogActions } from "@mui/material";
import { Button } from "@mui/material";
import { TextField } from "@mui/material";
import { useState } from "react";
import { useContext } from "react";
import { LoginContext } from "./Context";
// import { TestContext } from "./Context";

interface RegisterData {
    username: string,
    password: string,
    captcha: string,
}

function sendRegister(data: RegisterData): void {
    console.log(JSON.stringify(data));
    fetch("/api/register", { 
        method: "POST", 
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify(data) 
    });
}

function LoginDialog(): JSX.Element {
    // const [open, setOpen] = useState(openState);
    const [username, setUsername] = useState("");
    const [password, setPassword] = useState("");
    // const test = useContext(TestContext);

    const loginCTX = useContext(LoginContext);

    const handleClose = (): void => {
        loginCTX.setOpen?.(false);
    };

    const handleLogin = (): void => {
        console.log(username, password);
    };

    const handleRegister  = (): void => {
        sendRegister({ username: username, password: password, captcha: "test" });
    }

    return (
        <Dialog open={loginCTX.loginModalOpen} onClose={handleClose} sx={{ p: 2, top: "-40%" }}>
            <DialogTitle>Login</DialogTitle>
            <DialogContent>
                <DialogContentText>
                    Please enter your username and password.
                </DialogContentText>
                <TextField
                    autoFocus
                    margin="dense"
                    id="username"
                    label="Username"
                    type="text"
                    fullWidth
                    value={username}
                    onChange={(e): void => setUsername(e.target.value)}
                />
                <TextField
                    margin="dense"
                    id="password"
                    label="Password"
                    type="password"
                    fullWidth
                    value={password}
                    onChange={(e): void => setPassword(e.target.value)}
                />
            </DialogContent>
            <DialogActions>
                <Button onClick={handleLogin}>Login</Button>
            </DialogActions>
            <DialogActions>
                <Button onClick={handleRegister}>Register</Button>
            </DialogActions>
        </Dialog>
    );
}

export default LoginDialog;